// Plik: fig17_12.cpp
// Publiczna funkcja składowa zwracająca odwołanie
// do prywatnych danych składowych
#include <iostream>
#include "Time.h" // Dołączenie definicji klasy Time
using namespace std;

int main()
{
   Time t; // Utworzenie obiektu typu Time

   // Inicjalizacja hourRef z odwołaniem zwróconym przez funkcję badSetHour()
   unsigned int &hourRef = t.badSetHour( 20 ); // 20 to prawidłowa godzina

   cout << "Poprawna godzina przed modyfikacją: " << hourRef;
   hourRef = 30; // Użycie odwołania hourRef do przypisania nieprawidłowej wartości w obiekcie t typu Time
   cout << "\nNiepoprawna godzina po modyfikacji: " << t.getHour();

   // Niebezpieczeństwo: wywołanie funkcji zwraca odwołanie, 
   // które może zostać użyte w charakterze l-wartości!
   t.badSetHour( 12 ) = 74; // Przypisanie kolejnej nieprawidłowej wartości godzinie

   cout << "\n\n*************************************************\n"
      << "KIEPSKA PRAKTYKA PROGRAMISTYCZNA!!!!!!!!\n"
      << "t.badSetHour( 12 ) jako l-wartość, przypisanie nieprawidłowej wartości: "
      << t.getHour()
      << "\n*************************************************" << endl;
} // Koniec funkcji main()
