// Plik: fig18_09.cpp
// Program do testowania klasy Array
#include <iostream>
#include <stdexcept>
#include "Array.h"
using namespace std;

int main()
{
   Array integers1( 7 ); // 7-elementoy obiekt typu Array
   Array integers2; // Domyślnie 10-elementowy obiekt typu Array

   // Wyświetlenie zawartości obiektu integers1 i jego wielkości
   cout << "Wielkość tablicy integers1 wynosi " 
      << integers1.getSize()
      << "\nTablica po inicjalizacji:\n" << integers1;

   // Wyświetlenie zawartości obiektu integers2 i jego wielkości
   cout << "\nWielkość tablicy integers2 wynosi " 
      << integers2.getSize()
      << "\nTablica po inicjalizacji:\n" << integers2;

   // Pobranie danych wejściowych oraz wyświetlenie zawartości obiektów integers1 i integers2
   cout << "\nPodaj 17 liczb całkowitych:" << endl;
   cin >> integers1 >> integers2;

   cout << "\nPo dostarczeniu danych wejściowych obiekt Array zawiera:\n"
      << "integers1:\n" << integers1
      << "integers2:\n" << integers2;

   // Użycie przeciążonego operatora nierówności (!=)
   cout << "\nSprawdzanie: integers1 != integers2" << endl;

   if ( integers1 != integers2 )
      cout << "Obiekty integers1 i integers2 nie są takie same." << endl;

   // Utworzenie tablicy integers3 z użyciem integers1 jako metody
   // inicjalizacyjnej, a następnie wyświetlenie wielkości i zawartości tablicy
   Array integers3( integers1 ); // Wywołanie konstruktora kopiującego

   cout << "\nWielkość tablicy integers3 wynosi "
      << integers3.getSize()
      << "\nTablica po inicjalizacji:\n" << integers3;

   // Użycie przeciążonego operatora przypisania (=)
   cout << "\nPrzypisanie integers2 do integers1:" << endl;
   integers1 = integers2; // Zwróć uwagę, że docelowy obiekt typu Array jest mniejszy

   cout << "integers1:\n" << integers1
      << "integers2:\n" << integers2;

   // Użycie przeciążonego operatora równości (==)
   cout << "\nSprawdzanie: integers1 == integers2" << endl;

   if ( integers1 ==  integers2 )
      cout << "Obiekty integers1 i integers2 są równe." << endl;

   // Używanie przeciążonego operatora indeksu do utworzenia r-wartości.
   cout << "\nWartość integers1[5] wynosi " << integers1 [ 5 ];

   // Używanie przeciążonego operatora indeksu do utworzenia l-wartości
   cout << "\n\nPrzypisnie wartości 1000 do integers1[5]." << endl;
   integers1[ 5 ] = 1000;
   cout << "integers1:\n" << integers1;

   // Próba użycia indeksu spoza dozwolonego zakresu
   try                                                               
   {                                                                 
      cout << "\nPróba przypisnia wartości 1000 do integers1[15]" << endl;
      integers1[ 15 ] = 1000; // BŁĄD: indeks spoza dozwolonego zakresu
   } // Koniec bloku try                                                      
   catch ( out_of_range &ex )                                        
   {                                                                 
      cout << "Nastąpiło zgłoszenie wyjątku: " << ex.what() << endl;        
   } // Koniec bloku catch
} // Koniec funkcji main()
